import Vue from 'vue';
import Vuex from 'vuex';
import {deepClone} from '@utils/tools.js'
Vue.use(Vuex);

const store = new Vuex.Store({
  state:{
    pathInfo:{}, //患者信息-后续提交要用
    sysConfig:[], //系统配置项
    allMoudles:[], //模板
    originDatas:{},  //getById获取到的源数据
    datas:{},  //处理过的数据
    updata:false,  //更新数据
    imgFile:[],   //上传图片信息file
    imgSrc:{},   //上传的图片信息src
    symptom:{ //症状情况
      choose:[],
      origin:{},
      datas:{},
      text:""
    },
    diagnose:{ //诊疗
      origin:{},
      datas:{},
      text:"",
      imgFile:[],
      imgSrc:{}
    }
  },
  mutations:{
    savePathInfo(state,param){
      state.pathInfo = param;
    },
    saveSysConfig(state,param){
      state.sysConfig = param;
    },
    saveAll(state,param){
      state.allMoudles = param;
    },
    setOrigin(state,param){console.log("存值:",param)
      const type = parseInt(param.type);
      const data = param.data;
      switch(type){
        case 1: //症状情况
          state.symptom.origin = Object.assign({},state.symptom.origin,{[data.id]:data});
          break;
        case 2: //诊疗情况
          
          break;
        case 3:

          break;
        case 4:

          break;
        default:
          break;
      }
      // state.originDatas = Object.assign({},state.originDatas,{[param.id]:param});
    },
    setDatas(state,param){
      // let originData = state.datas[param.pId]?state.datas[param.pId]:JSON.parse(JSON.stringify(state.originDatas[param.pId]));
      const type = parseInt(param.type);
      switch(type){
        case 1:
          let originData = state.symptom.datas[param.pId]?state.symptom.datas[param.pId]:JSON.parse(JSON.stringify(state.symptom.origin[param.pId]));
          let list = originData.questionMapping.slice(0);
          for(let i=0; i<originData.questionMapping.length; i++){
            if(originData.questionMapping[i].id==param.data.id){
              list.splice(i,1,param.data);
            }
          }
          state.symptom.datas[param.pId] = Object.assign({},state.symptom.origin[param.pId],{questionMapping:list});
          break;
        case 2: //诊疗情况
          break;
        case 3:

          break;
        case 4:

          break;
        default:
          break;
      }
      
    },
    getUpdate(state){//更新数据
      state.updata = !state.updata;
    },
    setImgFile(state,param){//区别模块
      const type = parseInt(param.type);
      switch(type){
        case 1:

          break;
        case 2: //诊疗情况
          state.diagnose.imgFile.push(param);
          break;
        case 3:

          break;
        case 4:

          break;
        default:
          break;
      }
      
    },
    setImgSrc(state,param){
      const key = param.key;
      const src = param.src;
      const type = parseInt(param.type);
      switch(type){
        case 1:

          break;
        case 2:
          state.diagnose.imgSrc = Object.assign({},state.diagnose.imgSrc,{[key]:src});
          break;
        case 3:

          break;
        case 4:

          break;
        default:
          break;
      }
      
    },
    deleImg(state,param){
      const key = param.key;
      const type = parseInt(param.type);
      switch(type){
        case 1:

          break;
        case 2:
          let data = state.diagnose.imgFile;
          for(let i=0; i<data.length;i++){
            if(data[i].key==key){
              data.splice(i,1)
            }
          }
          break;
        case 3:

          break;
        case 4:

          break;
        default:
          break;
      }
      
    },
    deleSrc(state,param){
      const key = param.key;
      const type = parseInt(param.type);
      switch(type){
        case 1:

          break;
        case 2:
          let data = state.diagnose.imgFile;
          let obj = state.diagnose.imgSrc;
          delete(obj[key]);
          state.diagnose.imgSrc = Object.assign({},obj);
          break;
        case 3:

          break;
        case 4:

          break;
        default:
          break;
      }
      
    },
  }
})

export default store;